using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_Tarifas_SalasPrecios_Datos
    {
        #region MODELOS

        #region Modelo Listado
        private List<HPV_Tarifas_SalasPrecios> g_lst_HPV_Tarifas_SalasPrecios = null;

        public List<HPV_Tarifas_SalasPrecios> Obtener_ModeloListado_Por_IdTarifa(long _lng_idTarifa)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(HPV_Tarifas_SalasPrecios) + "." + nameof(HPV_Tarifas_SalasPrecios.idTarifa) + "=@idTarifa";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idTarifa",  _lng_idTarifa)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLV_AgrupacionesPLVLineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdTarifa), true);
            }

            return g_lst_HPV_Tarifas_SalasPrecios;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                          object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HPV_Tarifas_SalasPrecios = obj_Exferia_Entities.Database.SqlQuery<HPV_Tarifas_SalasPrecios>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Tarifas_SalasPrecios_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                      nameof(HPV_Tarifas_SalasPrecios.idTarifa) + "," +
                      nameof(HPV_Tarifas_SalasPrecios.idSala) + "," +
                      nameof(HPV_Tarifas_SalasPrecios.precio) + "," +
                      nameof(HPV_Tarifas_SalasPrecios.descuento) +
                " FROM " + nameof(HPV_Tarifas_SalasPrecios);
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Grabar(long _lng_idTarifa, List<HPV_Tarifas_SalasPrecios> _HPV_Tarifas_SalasPrecios)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.ProxyCreationEnabled = true;

                //Borrar Relaciones Antiguas ..............................................
                string str_SQL_Borrar = " DELETE FROM " + nameof(HPV_Tarifas_SalasPrecios) + " WHERE " + nameof(HPV_Tarifas_SalasPrecios.idTarifa) + "=" + _lng_idTarifa;
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Borrar);
                //.........................................................................

                //Grabar Relaciones Nuevas .................................................
                if (_HPV_Tarifas_SalasPrecios != null & _HPV_Tarifas_SalasPrecios.Count > 0)
                {
                    string str_SQL_Insertar = "";
                    foreach (HPV_Tarifas_SalasPrecios mdl_HPV_Tarifas_SalasPrecios in _HPV_Tarifas_SalasPrecios)
                    {
                        str_SQL_Insertar += " INSERT INTO " + nameof(HPV_Tarifas_SalasPrecios) + "(" + nameof(HPV_Tarifas_SalasPrecios.idTarifa) + "," + nameof(HPV_Tarifas_SalasPrecios.idSala) + "," + nameof(HPV_Tarifas_SalasPrecios.precio) + "," + nameof(HPV_Tarifas_SalasPrecios.descuento) + ") values (" + _lng_idTarifa + "," + mdl_HPV_Tarifas_SalasPrecios.idSala + "," + mdl_HPV_Tarifas_SalasPrecios.precio.ToString().Replace(',', '.') + "," + mdl_HPV_Tarifas_SalasPrecios.descuento.ToString().Replace(',', '.') + ")";
                    }

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insertar);
                }
                //.........................................................................
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Tarifas_SalasPrecios_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
